
#property copyright "Copyright 2015,dtlase@forexfactory.com."
#property link      "http://www.mql5.com"
#property strict
#property indicator_chart_window


sinput   int                     trade_Period_MA1            = 8;                 // Moving Average Period1
sinput   int                     trade_Period_MA2            = 21;                 // Moving Average Period2

string DefaultPairs[] = {"AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","CADCHF","CADJPY","CHFJPY","EURAUD","EURCAD","EURCHF","EURGBP","EURJPY","EURNZD","EURUSD","GBPAUD","GBPCAD","GBPCHF","GBPJPY","GBPNZD","GBPUSD","NZDCAD","NZDCHF","NZDJPY","NZDUSD","USDCAD","USDCHF","USDJPY"};



  
//--- input parameter
int Broker_Time_Offset = 3; // Broker Time adjustment (0 = GMT, 1 = GMT + 1 etc)

int Alert_Mod = 1; // Select Alert Mode 
long           thisChart;
int            timeOffset;
datetime       ServerLocalOffset;
datetime       prevTime,myTime,localtime;
bool           newBar = false;
datetime LastAlertTime;
string TMz, NBLz, AFz;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int OnInit()
{
       
   
   
   switch(Period())
   {    
      case 1:     TMz = "M1";  break;
      case 2:     TMz = "M2";  break;
      case 3:     TMz = "M3";  break;
      case 4:     TMz = "M4";  break;
      case 5:     TMz = "M5";  break;
      case 6:     TMz = "M6";  break;
      case 7:     TMz = "M7";  break;
      case 8:     TMz = "M8";  break;
      case 9:     TMz = "M9";  break;
      case 10:    TMz = "M10"; break;
      case 11:    TMz = "M11"; break;
      case 12:    TMz = "M12"; break;
      case 13:    TMz = "M13"; break;
      case 14:    TMz = "M14"; break;
      case 15:    TMz = "M15"; break;
      case 20:    TMz = "M20"; break;
      case 25:    TMz = "M25"; break;
      case 30:    TMz = "M30"; break;
      case 40:    TMz = "M40"; break;
      case 45:    TMz = "M45"; break;
      case 50:    TMz = "M50"; break;
      case 60:    TMz = "H1";  break;
      case 120:   TMz = "H2";  break;
      case 180:   TMz = "H3";  break;
      case 240:   TMz = "H4";  break;
      case 300:   TMz = "H5";  break;
      case 360:   TMz = "H6";  break;
      case 420:   TMz = "H7";  break;
      case 480:   TMz = "H8";  break;
      case 540:   TMz = "H9";  break;
      case 600:   TMz = "H10"; break;
      case 660:   TMz = "H11"; break;
      case 720:   TMz = "H12"; break;
      case 1440:  TMz = "D1";  break;
      case 10080: TMz = "W1";  break;
      case 43200: TMz = "M1";  break;  
   }   
   
                  
  
    LastAlertTime = TimeCurrent();   
//--- indicator buffers mapping
   EventSetTimer(1);
   thisChart = ChartID();

   ObjectCreate(thisChart,"BarTimer",OBJ_LABEL,0,20,40);

   datetime srvtime,tmpOffset;
   // Use RefreshRates to get the current time from TimeCurrent
   // Otherwise you'll just get the last known time
   RefreshRates();
   
   srvtime = TimeCurrent();
   // Modified
   localtime = TimeLocal()+TimeGMTOffset();
   if(TimeHour(srvtime)>TimeHour(localtime)){
      // Server Time is still ahead of us
      int newOffset = TimeHour(srvtime)-TimeHour(localtime);
      ServerLocalOffset = (newOffset*60*60);
   }else if(TimeHour(srvtime)<TimeHour(localtime)){
      // Server Time is Behind us
      int newOffset = TimeHour(localtime)-TimeHour(srvtime);
      ServerLocalOffset = (newOffset*60*60);
   }else{
      // No modification required
      ServerLocalOffset = srvtime;
   }
   localtime = TimeLocal()-ServerLocalOffset;
   
   tmpOffset = TimeSeconds(srvtime) - TimeSeconds(localtime);
   if(tmpOffset < 30 && tmpOffset >= 0){
      timeOffset = TimeSeconds(srvtime) - TimeSeconds(localtime);
   }
   return(INIT_SUCCEEDED);
}
  
void OnDeinit(const int reason)
  {
   EventKillTimer();
   ObjectDelete("BarTimer");
   ObjectDelete("NBz");

  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   
   
   if ((Alert_Mod == 1) && (LastAlertTime < Time[0]))
   {
      Alert("New Bar  -  ", Symbol(), "  -  " + TMz + "  -  " + AccountCompany());   
      LastAlertTime = Time[0];
      
      
      
        string fname = "DWM.csv";
  int M30candleUpDown,H1candleUpDown,H4candleUpDown,DcandleUpDown,WcandleUpDown,McandleUpDown;                         // Same folder for each TF (...\experts\files)
  int handle = FileOpen(fname, FILE_CSV|FILE_WRITE, ",");         // "," means that output data will be separated by commas; change if necessary
  if(handle>0)
    {
     FileWrite(handle,"Symb,M30Open,H1Open,H4Open,DOpen,WOpen,MOpen,PrevM30,PrevH1,PrevH4,PrevD,PrevW,PrevM,m30EMA8,m30EMA21,h1EMA8,h1EMA21,h4EMA8,h4EMA21,dEMA8,dEMA21,wEMA8,wEMA21,mEMA8,mEMA21,m30RSI2,h1RSI2,h4RSI2,dRSI2,wRSI2,mRSI2");    // This writes the Header record to the file (change or remove to suit)
     for(int i=0;i<ArraySize(DefaultPairs);i++){
     
  double OpenM30 = iOpen(DefaultPairs[i],PERIOD_M30,0);
  double OpenH1 = iOpen(DefaultPairs[i],PERIOD_H1,0);
  double OpenH4 = iOpen(DefaultPairs[i],PERIOD_H4,0);
  double OpenD = iOpen(DefaultPairs[i],PERIOD_D1,0);
  double OpenW = iOpen(DefaultPairs[i],PERIOD_W1,0);
  double OpenM = iOpen(DefaultPairs[i],PERIOD_MN1,0);
  
  
  
  double PrevOpenM30   = iOpen(DefaultPairs[i],PERIOD_M30,1);
  double PrevCloseM30 = iOpen(DefaultPairs[i],PERIOD_M30,1);
  double PrevHighM30   = iHigh(DefaultPairs[i],PERIOD_M30,1);
  double PrevLowM30 = iLow(DefaultPairs[i],PERIOD_M30,1);
  double PrevOpenH1   = iOpen(DefaultPairs[i],PERIOD_H1,1);
  double PrevCloseH1 = iOpen(DefaultPairs[i],PERIOD_H1,1);
  double PrevHighH1   = iHigh(DefaultPairs[i],PERIOD_H1,1);
  double PrevLowH1 = iLow(DefaultPairs[i],PERIOD_H1,1);
  double PrevOpenH4   = iOpen(DefaultPairs[i],PERIOD_H4,1);
  double PrevCloseH4 = iOpen(DefaultPairs[i],PERIOD_H4,1);
  double PrevHighH4   = iHigh(DefaultPairs[i],PERIOD_H4,1);
  double PrevLowH4 = iLow(DefaultPairs[i],PERIOD_H4,1);
  double PrevOpenD   = iOpen(DefaultPairs[i],PERIOD_D1,1);
  double PrevCloseD = iOpen(DefaultPairs[i],PERIOD_D1,1);
  double PrevHighD   = iHigh(DefaultPairs[i],PERIOD_D1,1);
  double PrevLowD = iLow(DefaultPairs[i],PERIOD_D1,1);
  double PrevOpenW   = iOpen(DefaultPairs[i],PERIOD_W1,1);
  double PrevCloseW = iOpen(DefaultPairs[i],PERIOD_W1,1);
  double PrevHighW   = iHigh(DefaultPairs[i],PERIOD_W1,1);
  double PrevLowW = iLow(DefaultPairs[i],PERIOD_W1,1);
  double PrevOpenM   = iOpen(DefaultPairs[i],PERIOD_MN1,1);
  double PrevCloseM = iOpen(DefaultPairs[i],PERIOD_MN1,1);
  double PrevHighM   = iHigh(DefaultPairs[i],PERIOD_MN1,1);
  double PrevLowM = iLow(DefaultPairs[i],PERIOD_MN1,1);
  
  if(PrevOpenM30>PrevCloseM30){M30candleUpDown=0;}
  else if(PrevOpenM30==PrevCloseM30){
      if(MathAbs(PrevOpenM30-PrevHighM30)>MathAbs(PrevOpenM30-PrevLowM30)){M30candleUpDown=1;}
      else if(MathAbs(PrevOpenM30-PrevHighM30)<MathAbs(PrevOpenM30-PrevLowM30)){M30candleUpDown=0;}
      else{M30candleUpDown=2;}}
  else{M30candleUpDown=1;}

  if(PrevOpenH1>PrevCloseH1){H1candleUpDown=0;}
  else if(PrevOpenH1==PrevCloseH1){
      if(MathAbs(PrevOpenH1-PrevHighH1)>MathAbs(PrevOpenH1-PrevLowH1)){H1candleUpDown=1;}
      else if(MathAbs(PrevOpenH1-PrevHighH1)<MathAbs(PrevOpenH1-PrevLowH1)){H1candleUpDown=0;}
      else{H1candleUpDown=2;}}
  else{H1candleUpDown=1;}

  if(PrevOpenH4>PrevCloseH4){H4candleUpDown=0;}
  else if(PrevOpenH4==PrevCloseH4){
      if(MathAbs(PrevOpenH4-PrevHighH4)>MathAbs(PrevOpenH4-PrevLowH4)){H4candleUpDown=1;}
      else if(MathAbs(PrevOpenH4-PrevHighH4)<MathAbs(PrevOpenH4-PrevLowH4)){H4candleUpDown=0;}
      else{H4candleUpDown=2;}}
  else{H4candleUpDown=1;}

  if(PrevOpenD>PrevCloseD){DcandleUpDown=0;}
  else if(PrevOpenD==PrevCloseD){
      if(MathAbs(PrevOpenD-PrevHighD)>MathAbs(PrevOpenD-PrevLowD)){DcandleUpDown=1;}
      else if(MathAbs(PrevOpenD-PrevHighD)<MathAbs(PrevOpenD-PrevLowD)){DcandleUpDown=0;}
      else{DcandleUpDown=2;}}
  else{DcandleUpDown=1;}

  if(PrevOpenW>PrevCloseW){WcandleUpDown=0;}
  else if(PrevOpenW==PrevCloseW){
      if(MathAbs(PrevOpenW-PrevHighW)>MathAbs(PrevOpenW-PrevLowW)){WcandleUpDown=1;}
      else if(MathAbs(PrevOpenW-PrevHighW)<MathAbs(PrevOpenW-PrevLowW)){WcandleUpDown=0;}
      else{WcandleUpDown=2;}}
  else{WcandleUpDown=1;}

  if(PrevOpenM>PrevCloseM){McandleUpDown=0;}
  else if(PrevOpenM==PrevCloseM){
      if(MathAbs(PrevOpenM-PrevHighM)>MathAbs(PrevOpenM-PrevLowM)){McandleUpDown=1;}
      else if(MathAbs(PrevOpenM-PrevHighM)<MathAbs(PrevOpenM-PrevLowM)){McandleUpDown=0;}
      else{McandleUpDown=2;}}
  else{McandleUpDown=1;}
  
  

  double m30MA_EMA8 = iMA(DefaultPairs[i],PERIOD_M30,trade_Period_MA1,0,MODE_EMA,PRICE_OPEN,0);
  double m30MA_EMA21 = iMA(DefaultPairs[i],PERIOD_M30,trade_Period_MA2,0,MODE_EMA,PRICE_OPEN,0);
  double h1MA_EMA8 = iMA(DefaultPairs[i],PERIOD_H1,trade_Period_MA1,0,MODE_EMA,PRICE_OPEN,0);
  double h1MA_EMA21 = iMA(DefaultPairs[i],PERIOD_H1,trade_Period_MA2,0,MODE_EMA,PRICE_OPEN,0);
  double h4MA_EMA8 = iMA(DefaultPairs[i],PERIOD_H4,trade_Period_MA1,0,MODE_EMA,PRICE_OPEN,0);
  double h4MA_EMA21 = iMA(DefaultPairs[i],PERIOD_H4,trade_Period_MA2,0,MODE_EMA,PRICE_OPEN,0);
  double dMA_EMA8 = iMA(DefaultPairs[i],PERIOD_D1,trade_Period_MA1,0,MODE_EMA,PRICE_OPEN,0);
  double dMA_EMA21 = iMA(DefaultPairs[i],PERIOD_D1,trade_Period_MA2,0,MODE_EMA,PRICE_OPEN,0);
  double wMA_EMA8 = iMA(DefaultPairs[i],PERIOD_W1,trade_Period_MA1,0,MODE_EMA,PRICE_OPEN,0);
  double wMA_EMA21 = iMA(DefaultPairs[i],PERIOD_W1,trade_Period_MA2,0,MODE_EMA,PRICE_OPEN,0);
  double mMA_EMA8 = iMA(DefaultPairs[i],PERIOD_MN1,trade_Period_MA1,0,MODE_EMA,PRICE_OPEN,0);
  double mMA_EMA21 = iMA(DefaultPairs[i],PERIOD_MN1,trade_Period_MA2,0,MODE_EMA,PRICE_OPEN,0);


  double m30RSI2 = iRSI(DefaultPairs[i],PERIOD_M30,2,PRICE_CLOSE,1);
  double h1RSI2 = iRSI(DefaultPairs[i],PERIOD_H1,2,PRICE_CLOSE,1);
  double h4RSI2 = iRSI(DefaultPairs[i],PERIOD_H4,2,PRICE_CLOSE,1);
  double dRSI2 = iRSI(DefaultPairs[i],PERIOD_D1,2,PRICE_CLOSE,1);
  double wRSI2 = iRSI(DefaultPairs[i],PERIOD_W1,2,PRICE_CLOSE,1);
  double mRSI2 = iRSI(DefaultPairs[i],PERIOD_MN1,2,PRICE_CLOSE,1);
   

       FileWrite(handle, DefaultPairs[i],OpenM30,OpenH1,OpenH4,OpenD,OpenW,OpenM,M30candleUpDown,H1candleUpDown,H4candleUpDown,DcandleUpDown,WcandleUpDown,McandleUpDown,m30MA_EMA8,m30MA_EMA21,h1MA_EMA8,h1MA_EMA21,h4MA_EMA8,h4MA_EMA21,dMA_EMA8,dMA_EMA21,wMA_EMA8,wMA_EMA21,mMA_EMA8,mMA_EMA21,m30RSI2,h1RSI2,h4RSI2,dRSI2,wRSI2,mRSI2);
       //FileWrite(handle, DefaultPairs[i],OpenD,OpenW,OpenM,signals[i].PrevSignalD,signals[i].PrevSignalW,signals[i].PrevSignalM,dMA_EMA8,dMA_EMA21,wMA_EMA8,wMA_EMA21,mMA_EMA8,mMA_EMA21);
       }
     FileClose(handle);
     Comment("History output complete");     // Display a comment in the upper left corner of the chart to advise that process is complete
     Alert("History output complete");
    }
      
      
   }	
   else if ((Alert_Mod == 2) && (LastAlertTime < Time[0]))
   {
      PlaySound("Alert.wav");
      LastAlertTime = Time[0];
      Alert("Great, bar close!");
   }   
   
   return(rates_total);
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{
   if(Period() >0 && Period() <1440)
   {
      localtime = TimeLocal()+(TimeGMTOffset()+((60*60)*Broker_Time_Offset));
      if(ObjectFind(thisChart,"BarTimer")>=0)
      {
         ObjectCreate(0,"BarTimer",OBJ_LABEL,0,0,0);
         ObjectSetInteger(0,"BarTimer",OBJPROP_ANCHOR,ANCHOR_RIGHT_UPPER);
         ObjectSet("BarTimer",OBJPROP_CORNER,1);
         ObjectSet("BarTimer",OBJPROP_XDISTANCE,20);
         ObjectSet("BarTimer",OBJPROP_YDISTANCE,40);
         ObjectSetText("BarTimer",TimeToStr(Time[0]+Period()*60-localtime-timeOffset,TIME_SECONDS ),14,"Courier",clrDarkOrange);
     } 
   }
}

